/*
   program : various

   $Source: /home/yee/C/RCS/util.h,v $
   $Author: yee $
   $Date: 1999/03/09 01:52:38 $
   $Revision: 1.13 $

   Miscellaneous macros.

   Parameters : none

   Assumptions : none known

   Bugs : none known

   To Do : nothing

   $Log: util.h,v $
   Revision 1.13  1999/03/09 01:52:38  yee
   *** empty log message ***

   Revision 1.12  1999/02/10 16:39:47  yee
   *** empty log message ***

   char rcs_id[] = "$Id: util.h,v 1.13 1999/03/09 01:52:38 yee Exp $";

   Copyright 1997,1998,1999 by Conway Yee.  All rights reserved.
 */
#include <stdio.h>

#include "style.h"

#ifndef UTIL_H
#define UTIL_H

/* USAGE() is a macro which prints out an error message.

   The error message is of the form:
       char *msg[] = {
               "msg #1",
               "msg #2",
               ...
               "msg #n",
               NULL
             }
 */

#define USAGE(msg) {                        \
            int i=0;  /* counter */           \
                                              \
            do {                              \
             fprintf(stderr,"%s\n",msg[i++]); \
            } while(msg[i] != NULL);          \
                                              \
            exit(errno);                      \
          }

                           /* turns a string to all UPPER or lower case */
#define STOLOWER(s) {char *p=s;for(;*p;p++) *p=tolower(*p);}
#define STOUPPER(s) {char *p=s;for(;*p;p++) *p=toupper(*p);}

#ifndef NUL
#define NUL '\0'
#endif

#define POUND '#'
#define NL '\n'
#define QUOTE '"'
#define SPACE ' '
#define BACKSLASH '\\'
#define PLUS '+'
#define MINUS '-'
#define PERIOD '.'
#define ZERO '0'

  PUBLIC void *AddElement(void *list,int size);

  PUBLIC int StringLength(char *s,char tok);
  PUBLIC char *StringCopy(char *s,char *ct,char tok,int n);

  PUBLIC char *strbuff(FILE *fptr,char *str);
  PUBLIC char *fgetline(void *stream,int (*func)());
#endif UTIL_H
